<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form
      v-show="showSearch"
      ref="queryForm"
      :model="queryParams"
      size="small"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="名字" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入名字"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="性别" prop="sex">
        <el-select
          v-model="queryParams.sex"
          placeholder="请选择性别"
          clearable
          size="small"
        >
          <el-option
            v-for="dict in getDictDatas(DICT_TYPE.SYSTEM_USER_SEX)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="出生年" prop="birthday">
        <el-date-picker
          v-model="queryParams.birthday"
          clearable
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择出生年"
        />
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          style="width: 240px"
          value-format="yyyy-MM-dd HH:mm:ss"
          type="daterange"
          range-separator="-"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="['00:00:00', '23:59:59']"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 三色灯串口连接亮灯关灯 -->
    <el-row :gutter="10">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="connect()"
        >连接</el-button>
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="connectAndWrite()"
        >亮灯</el-button>
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="closeAndWrite()"
        >关闭</el-button>
      </el-col>
    </el-row>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['mes:demo01-contact:create']"
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="openForm(undefined)"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['mes:demo01-contact:export']"
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :show-search.sync="showSearch" @queryTable="getList" />
    </el-row>

    <el-table
      v-loading="loading"
      :data="list"
      :stripe="true"
      :show-overflow-tooltip="true"
    >
      <el-table-column label="编号" align="center" prop="id" />
      <el-table-column label="名字" align="center" prop="name" />
      <el-table-column label="性别" align="center" prop="sex">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.SYSTEM_USER_SEX" :value="scope.row.sex" />
        </template>
      </el-table-column>
      <el-table-column
        label="出生年"
        align="center"
        prop="birthday"
        width="180"
      >
        <template v-slot="scope">
          <span>{{ parseTime(scope.row.birthday) }}</span>
        </template>
      </el-table-column>
      <el-table-column
        label="简介"
        align="center"
        prop="description"
        show-overflow-tooltip
      />
      <el-table-column
        label="头像"
        align="center"
        prop="avatar"
        show-overflow-tooltip
      />
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        width="180"
      >
        <template v-slot="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template v-slot="scope">
          <el-button
            v-hasPermi="['mes:demo01-contact:update']"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="openForm(scope.row.id)"
          >修改</el-button>
          <el-button
            v-hasPermi="['mes:demo01-contact:delete']"
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNo"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!-- 对话框(添加 / 修改) -->
    <Demo01ContactForm ref="formRef" @success="getList" />
  </div>
</template>

<script>
import * as Demo01ContactApi from '@/api/infra/testDemo/testDemo'
import Demo01ContactForm from './Demo01ContactForm.vue'
export default {
  name: 'Demo01Contact',
  components: {
    Demo01ContactForm
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 示例联系人列表
      list: [],
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,
      // 选中行
      currentRow: {},

      // 串口连接端口
      port: null,
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        name: null,
        sex: null,
        birthday: null,
        description: null,
        avatar: null,
        createTime: []
      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    /** 查询列表 */
    async getList() {
      try {
        this.loading = true
        const res = await Demo01ContactApi.getDemo01ContactPage(this.queryParams)
        this.list = res.data.list
        this.total = res.data.total
      } finally {
        this.loading = false
      }
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    /** 添加/修改操作 */
    openForm(id) {
      this.$refs['formRef'].open(id)
    },
    /** 删除按钮操作 */
    async handleDelete(row) {
      const id = row.id
      await this.$modal.confirm('是否确认删除示例联系人编号为"' + id + '"的数据项?')
      try {
        await Demo01ContactApi.deleteDemo01Contact(id)
        await this.getList()
        this.$modal.msgSuccess('删除成功')
      } catch {
        //
      }
    },
    /** 导出按钮操作 */
    async handleExport() {
      await this.$modal.confirm('是否确认导出所有示例联系人数据项?')
      try {
        this.exportLoading = true
        const res = await Demo01ContactApi.exportDemo01ContactExcel(this.queryParams)
        this.$download.excel(res, '示例联系人.xls')
      } catch {
        //
      } finally {
        this.exportLoading = false
      }
    },
    // 连接
    async connect() {
      try {
        this.port = await navigator.serial.requestPort()
        await this.port.open({ baudRate: 9606, timeout: 1 })
        this.$modal.msgSuccess('连接成功!')
      } catch (error) {
        this.$modal.msgWarning('err' + error)
      }
    },

    // 连接串口-亮灯
    async connectAndWrite() {
      try {
        // const port = await navigator.serial.requestPort()
        // await port.open({ baudRate: 9602, timeout: 1 })

        // 转换为Uint8Array以便写入串口
        const hex_data_1 = new Uint8Array([0xa0, 0x02, 0x01, 0xa3])

        const writer = this.port.writable.getWriter()

        // 写入数据包
        await writer.write(hex_data_1)

        // 如果需要连续发送多个指令，在这里可以继续写入（但请确保硬件设备能够正确处理）
        // await writer.write(hex_data_2)

        // 在完成所有写入操作之后，先释放 writer 锁，再关闭串口连接
        writer.releaseLock()

        // 确保 writer 已经释放锁后再关闭串口
        await new Promise(resolve => setTimeout(resolve, 10)) // 可以根据实际情况调整延时
        // this.port.close()
      } catch (error) {
        console.error('err', error)
      }
    },
    // 关闭
    async closeAndWrite() {
      try {
        // 转换为Uint8Array以便写入串口
        // 关闭绿灯
        const hex_data_2 = new Uint8Array([0xa0, 0x02, 0x00, 0xa2])

        const writer = this.port.writable.getWriter()

        // 写入数据包
        await writer.write(hex_data_2)

        // 在完成所有写入操作之后，先释放 writer 锁，再关闭串口连接
        writer.releaseLock()

        // 确保 writer 已经释放锁后再关闭串口
        await new Promise(resolve => setTimeout(resolve, 10)) // 可以根据实际情况调整延时
        this.port.close()
      } catch (error) {
        console.error('err', error)
      }
    }
  }
}
</script>
